/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   anyremote@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stream.h>
#include <qbutton.h>
#include <qlineedit.h>
#include <qfile.h>
#include <qtextedit.h>

#include <kfiledialog.h>
#include <kurlrequester.h>

#include "logger.h"
#include "kanyremote.h"
#include "kanyremotewidget.h"
#include "ar_editor.h"

extern logger2 *theLog;

extern KAnyRemote *mainWin;
extern void logger(char *head, const char *str);

KAnyRemoteWidget::KAnyRemoteWidget(QWidget* parent, const char* name, WFlags fl)
        : KAnyRemoteWidgetBase(parent,name,fl)
{	
    theEditor = NULL;
}

KAnyRemoteWidget::~KAnyRemoteWidget()
{}

/*$SPECIALIZATION$*/

void KAnyRemoteWidget::okClicked()
{
    theLog->debug("KAnyRemoteWidget::okClicked() ");
    mainWin->hide();
}

void KAnyRemoteWidget::cancelClicked()
{
    theLog->debug("KAnyRemoteWidget::cancelClicked()");
    fileName->setURL("");
    mainWin->hide();
}

void KAnyRemoteWidget::editClicked()
{
	theLog->debug("KAnyRemoteWidget::editClicked()");

        // Don't cal this twice
        if (theEditor == NULL) {
        	QFile file(fileName->url());
                if (file.open(IO_ReadOnly)) {
                	QTextStream stream( &file );
                        QString text = stream.read();
                        file.close();

                        theEditor = new AR_Editor(fileName->url());
                        connect((const QObject *) theEditor->pushButton1, (const char *) SIGNAL( clicked() ), 
                             (const QObject *) this, (const char *) SLOT(slotEditCfgClose()));
                        connect((const QObject *) theEditor->pushButton2, (const char *) SIGNAL( clicked() ), 
                             (const QObject *) this, (const char *) SLOT(slotEditCfgClose()));

                        theEditor->textEdit1->setText(text);
                        theEditor->show();
                } else {
                	theLog->error("Can't open cfg file for reading");
                }
        }
}

void KAnyRemoteWidget::slotEditCfgClose()
{
	theLog->debug("KAnyRemoteWidget::slotEditCfgClose()");
        theEditor->hide();
        delete theEditor;
        theEditor = NULL;
}
#include "kanyremotewidget.moc"

